## groonga 8.0.0

=== CMakeLists.txt ===
# Copyright(C) 2012-2017 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

# https://buildbot.askmonty.org/buildbot/builders/work-amd64-valgrind/builds/5263/steps/compile/logs/stdio
# says CMake 2.6.2... We want to drop old software support...
cmake_minimum_required(VERSION 2.6.2)
# cmake_minimum_required(VERSION 2.6.4) # CentOS 5
set(GRN_PROJECT_NAME "groonga")
set(GRN_PROJECT_LABEL "Groonga")
project("${GRN_PROJECT_NAME}")

if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
  set(GRN_BUNDLED FALSE)
else()
  set(GRN_BUNDLED TRUE)
endif()

if(MSVC)
  if(MSVC_VERSION LESS 1800)
    set(GRN_OLD_MSVC_MESSAGE "Groonga supports only MSVC 2013 or later")
    if(GRN_BUNDLED)
      message(STATUS ${GRN_OLD_MSVC_MESSAGE})
      return()
    else()
      message(FATAL_ERROR ${GRN_OLD_MSVC_MESSAGE})
    endif()
  endif()
endif()

if(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANGCC ON)
endif()
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  set(CMAKE_COMPILER_IS_CLANGCXX ON)
endif()

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/base_version" VERSION)
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/version.sh")
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/version.sh" GRN_VERSION)
else()
  if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/version.sh")
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git" AND EXISTS "/bin/sh")
      execute_process(COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/version-gen.sh")
      file(READ "${CMAKE_CURRENT_BINARY_DIR}/version.sh" GRN_VERSION)
    else()
      set(GRN_VERSION "${VERSION}")
    endif()
  endif()
endif()
string(REGEX REPLACE "(^.*=|\n)" "" GRN_VERSION "${GRN_VERSION}")
string(REGEX REPLACE "\\." "," GRN_VERSION_RC "${GRN_VERSION}")
string(REGEX REPLACE "-.*$" "" GRN_VERSION_RC "${GRN_VERSION_RC}")

include(CheckIncludeFile)
include(CheckFunctionExists)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(FindPkgConfig)
include(${CMAKE_CURRENT_SOURCE_DIR}/build/cmake_modules/ReadFileList.cmake)

if(DEFINED GRN_EMBED)
  set(GRN_EMBED_DEFAULT ${GRN_EMBED})
else()
  set(GRN_EMBED_DEFAULT OFF)
endif()
option(GRN_EMBED
  "Build as a static library to embed into an application"
  ${GRN_EMBED_DEFAULT})

set(BIN_DIR "bin")
set(SBIN_DIR "sbin")
set(LIB_DIR "lib")
set(PDB_DIR "${LIB_DIR}/pdb")
set(INCLUDE_DIR "include")
set(GRN_INCLUDE_DIR "include/groonga")
set(DATA_DIR "share")
set(GRN_DATA_DIR "${DATA_DIR}/${GRN_PROJECT_NAME}")
set(CONFIG_DIR "etc")
set(GRN_CONFIG_DIR "${CONFIG_DIR}/${GRN_PROJECT_NAME}")
set(GRN_CONFIG_PATH "${CMAKE_INSTALL_PREFIX}/${GRN_CONFIG_DIR}/groonga.conf")

set(GRN_LOG_PATH
  "${CMAKE_INSTALL_PREFIX}/var/log/${GRN_PROJECT_NAME}/${GRN_PROJECT_NAME}.log"
  CACHE FILEPATH "log file path")
set(GRN_DEFAULT_ENCODING
  "utf8"
  CACHE STRING "Groonga's default encoding")
set(GRN_DEFAULT_MATCH_ESCALATION_THRESHOLD
  0
  CACHE STRING "Groonga's default match escalation threshold")
set(GRN_DEFAULT_DOCUMENT_ROOT_BASE
  "html/admin"
  CACHE PATH "Groonga's default document root base path")
set(GRN_DEFAULT_RELATIVE_DOCUMENT_ROOT
  "share/${GRN_PROJECT_NAME}/${GRN_DEFAULT_DOCUMENT_ROOT_BASE}"
  CACHE PATH "Groonga's default relative document root")
set(GRN_DEFAULT_DOCUMENT_ROOT
  "${CMAKE_INSTALL_PREFIX}/${GRN_DATA_DIR}/${GRN_DEFAULT_DOCUMENT_ROOT_BASE}"
  CACHE PATH "Groonga's default document root")
set(GRN_DEFAULT_DB_KEY
  "auto"
  CACHE STRING "Groonga's default DB key management algorithm")
set(GRN_STACK_SIZE
  1024
  CACHE STRING
  "DANGER!!! Groonga's stack size. Normarlly, you should not change this variable.")
set(GRN_LOCK_TIMEOUT
  900000
  CACHE STRING
  "timeout to acquire a lock.")
set(GRN_LOCK_WAIT_TIME_NANOSECOND
  1000000
  CACHE STRING
  "wait time in nanosecond to acquire a lock.")
set(GRN_RELATIVE_PLUGINS_DIR
  "${LIB_DIR}/${GRN_PROJECT_NAME}/plugins")
set(GRN_PLUGINS_DIR
  "${CMAKE_INSTALL_PREFIX}/${GRN_RELATIVE_PLUGINS_DIR}")
set(GRN_PLUGIN_SUFFIX "${CMAKE_SHARED_MODULE_SUFFIX}")
set(GRN_DLL_FILENAME
  "${CMAKE_SHARED_LIBRARY_PREFIX}groonga${CMAKE_SHARED_LIBRARY_SUFFIX}")
set(GRN_QUERY_EXPANDER_TSV_RELATIVE_SYNONYMS_FILE
  "${GRN_CONFIG_DIR}/synonyms.tsv")
set(GRN_QUERY_EXPANDER_TSV_SYNONYMS_FILE
  "${CMAKE_INSTALL_PREFIX}/${GRN_QUERY_EXPANDER_TSV_RELATIVE_SYNONYMS_FILE}")
set(GRN_RELATIVE_RUBY_SCRIPTS_DIR
  "${LIB_DIR}/${GRN_PROJECT_NAME}/scripts/ruby")
set(GRN_RUBY_SCRIPTS_DIR
  "${CMAKE_INSTALL_PREFIX}/${GRN_RELATIVE_RUBY_SCRIPTS_DIR}")


if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(GRN_C_COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS} -std=gnu99")
endif()


macro(check_cflag flag)
  string(REGEX REPLACE "[-=]" "_" temporary_variable_name ${flag})
  string(TOUPPER "${temporary_variable_name}" temporary_variable_name)
  set(temporary_variable_name "CFLAG${temporary_variable_name}")
  check_c_compiler_flag(${flag} ${temporary_variable_name})
  if(${temporary_variable_name})
    set(GRN_C_COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS} ${flag}")
  endif()
endmacro()

macro(check_cxxflag flag)
  string(REGEX REPLACE "[-=]" "_" temporary_variable_name ${flag})
  string(TOUPPER "${temporary_variable_name}" temporary_variable_name)
  set(temporary_variable_name "CXXFLAG${temporary_variable_name}")
  check_cxx_compiler_flag(${flag} ${temporary_variable_name})
  if(${temporary_variable_name})
    set(GRN_CXX_COMPILE_FLAGS "${GRN_CXX_COMPILE_FLAGS} ${flag}")
  endif()
endmacro()

macro(check_build_flag flag)
  check_cflag(${flag})
  check_cxxflag(${flag})
endmacro()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGCXX)
  check_build_flag("-Wall")
  check_build_flag("-Wno-unused-but-set-variable")
  check_build_flag("-Wno-unused-parameter")
  check_cflag("-Wno-pointer-sign")
  check_build_flag("-Wformat")
  check_build_flag("-Wno-format-truncation")
  check_build_flag("-Wstrict-aliasing=2")
  check_build_flag("-fno-strict-aliasing")
  check_build_flag("-Wno-disabled-optimization")
  check_build_flag("-Wfloat-equal")
  check_build_flag("-Wpointer-arith")
  check_cflag("-Wbad-function-cast")
  if(NOT CMAKE_COMPILER_IS_CLANGCXX)
    check_build_flag("-Wcast-align")
  endif()
  # check_build_flag("-Wredundant-decls")
  check_build_flag("-Wwrite-strings")
  check_cxxflag("-fexceptions")
  check_cxxflag("-fimplicit-templates")
endif()

if(NOT DEFINED CMAKE_C_COMPILE_OPTIONS_PIC)
  # For old CMake
  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGCXX)
    check_build_flag("-fPIC")
  endif()
endif()

option(GRN_WITH_DEBUG "enable debug build." OFF)
if(GRN_WITH_DEBUG)
  if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGCXX)
    set(GRN_C_COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS} -g3 -O0")
    set(GRN_CXX_COMPILE_FLAGS "${GRN_CXX_COMPILE_FLAGS} -g3 -O0")
  endif()
endif()

add_definitions(
  -DHAVE_CONFIG_H
  )
if(GRN_EMBED)
  add_definitions(-DGRN_EMBEDDED)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANGCXX)
  set(_GNU_SOURCE TRUE)
endif()

include_directories(
  BEFORE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/lib
  )

macro(ac_check_headers header)
  string(REGEX REPLACE "[/.]" "_" output_variable_name ${header})
  string(TOUPPER "${output_variable_name}" output_variable_name)
  set(output_variable_name "HAVE_${output_variable_name}")
  check_include_file(${header} ${output_variable_name})
endmacro()

macro(ac_check_funcs function)
  string(TOUPPER "${function}" output_variable_name)
  set(output_variable_name "HAVE_${output_variable_name}")
  check_function_exists(${function} ${output_variable_name})
endmacro()

macro(ac_check_symbols symbol files)
  string(TOUPPER "${symbol}" output_variable_name)
  set(output_variable_name "HAVE_${output_variable_name}")
  check_symbol_exists(${symbol} ${files} ${output_variable_name})
endmacro()

macro(ac_check_lib library function)
  string(REGEX REPLACE "[/.]" "_" output_variable_base_name ${library})
  string(TOUPPER "${output_variable_base_name}" output_variable_base_name)
  set(output_variable_name "HAVE_LIB${output_variable_base_name}")
  set(location "${ARG2}")
  check_library_exists(${library} ${function} "${location}"
    ${output_variable_name})
  if(${output_variable_name})
    set(${output_variable_base_name}_LIBS "${library}")
  endif()
endmacro()

include(build/ac_macros/check_headers.m4)
include(build/ac_macros/check_functions.m4)

ac_check_symbols(fpclassify math.h)
ac_check_lib(m fpclassify)

ac_check_lib(dl dlopen)
ac_check_lib(execinfo backtrace)
if(HAVE_LIBEXECINFO)
  set(HAVE_BACKTRACE TRUE)
else()
  ac_check_funcs(backtrace)
endif()
ac_check_lib(rt clock_gettime)
if(HAVE_LIBRT)
  set(HAVE_CLOCK_GETTIME TRUE)
endif()
if(GRN_EMBED)
  check_library_exists(stdc++ __cxa_begin_catch "${ARG2}"
    STDCPP)
  if(STDCPP)
    set(STDCPP_LIBS "stdc++")
  endif()
endif()

if(UNIX)
  ac_check_headers(pthread.h)
  ac_check_lib(pthread pthread_mutex_init)
  if(NOT ${HAVE_LIBPTHREAD})
    message(FATAL_ERROR "No libpthread found")
  endif()
  ac_check_funcs(pthread_mutexattr_setpshared)
  ac_check_funcs(pthread_condattr_setpshared)
endif()

option(GRN_WITH_NFKC "use NFKC based UTF8 normalization." ON)

if(WIN32)
  ac_check_headers(winsock2.h)
  if(NOT ${HAVE_WINSOCK2_H})
    message(FATAL_ERROR "No winsock2.h found")
  endif()

  # FIXME: CMake couldn't detect ws2_32.lib on Windows 8 64bit.
  # It may be caused by missing library search path for ws2_32.lib.
  # It seems that Visual Studio (devenv.exe) can find it but link.exe
  # can't. "cmake --build" can find it because it uses Visual Studio
  # internally. So we assume that we always have ws2_32.lib on Windows.
  # ac_check_lib(ws2_32 select)
  set(HAVE_LIBWS2_32 TRUE)
  set(WS2_32_LIBS "ws2_32.lib")

  SET(DBGHELP_LIBS "dbghelp.lib")

  set(USE_SELECT TRUE)
else()
  ac_check_headers(sys/epoll.h)
  if(${HAVE_SYS_EPOLL_H})
    ac_check_funcs(epoll_create)
    if(${HAVE_EPOLL_CREATE})
      set(USE_EPOLL TRUE)
    endif()
  endif()

  if(NOT USE_EPOLL)
    ac_check_headers(sys/event.h)
    if(${HAVE_SYS_EVENT_H})
      ac_check_funcs(kevent)
      if(${HAVE_KEVENT})
        set(USE_KQUEUE TRUE)
      endif()
    endif()

    if(NOT USE_KQUEUE)
      ac_check_headers(poll.h)
      if(${HAVE_SYS_POLL_H})
        ac_check_funcs(poll)
        if(${HAVE_POLL})
          set(USE_POLL TRUE)
        endif()
      endif()

      if(NOT USE_POLL)
        ac_check_funcs(select)
        if(${HAVE_SELECT})
          set(USE_SELECT TRUE)
          ac_check_headers(sys/select.h)
        endif()

        if(NOT USE_SELECT)
          message(FATAL_ERROR "All epoll/kqueue/poll/select are missing")
        endif()
      endif()
    endif()
  endif()
endif()

set(GRN_WITH_ZLIB "auto"
  CACHE STRING "Support data compression by zlib.")
if(NOT ${GRN_WITH_ZLIB} STREQUAL "no")
  ac_check_lib(z compress)
  if(NOT HAVE_LIBZ)
    if(${GRN_WITH_ZLIB} STREQUAL "yes")
      message(FATAL_ERROR "No libz found")
    endif()
    set(GRN_WITH_ZLIB "no")
  endif()
endif()

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/bundled_lz4_version"
  GRN_BUNDLED_LZ4_VERSION)
string(STRIP
  "${GRN_BUNDLED_LZ4_VERSION}"
  GRN_BUNDLED_LZ4_VERSION)
option(GRN_WITH_BUNDLED_LZ4 "use bundled LZ4" OFF)

set(GRN_WITH_LZ4 "auto"
  CACHE STRING "Support data compression by LZ4.")
if(NOT ${GRN_WITH_LZ4} STREQUAL "no")
  if(GRN_WITH_BUNDLED_LZ4)
    set(LIBLZ4_INCLUDE_DIRS

=== lib/CMakeLists.txt ===
# Copyright(C) 2012-2016 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

add_definitions(
  -DGRN_DAT_EXPORT
  )

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/dat
  ${ONIGMO_INCLUDE_DIRS}
  ${MRUBY_INCLUDE_DIRS}
  ${LIBLZ4_INCLUDE_DIRS}
  ${LIBZSTD_INCLUDE_DIRS}
  ${MESSAGE_PACK_INCLUDE_DIRS})

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/c_sources.am LIBGROONGA_C_SOURCES)
read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/cpp_sources.am LIBGROONGA_CPP_SOURCES)
read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/dat/sources.am LIBGRNDAT_SOURCES)
string(REGEX REPLACE "([^;]+)" "dat/\\1"
  LIBGRNDAT_SOURCES "${LIBGRNDAT_SOURCES}")
read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mrb/sources.am LIBGRNMRB_SOURCES)
string(REGEX REPLACE "([^;]+)" "mrb/\\1"
  LIBGRNMRB_SOURCES "${LIBGRNMRB_SOURCES}")
read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/proc/sources.am LIBGRNPROC_SOURCES)
string(REGEX REPLACE "([^;]+)" "proc/\\1"
  LIBGRNPROC_SOURCES "${LIBGRNPROC_SOURCES}")
read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/ts/sources.am LIBGRNTS_SOURCES)
string(REGEX REPLACE "([^;]+)" "ts/\\1"
  LIBGRNTS_SOURCES "${LIBGRNTS_SOURCES}")

if(WIN32)
  configure_file(
    "metadata.rc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/metadata.rc"
    @ONLY)
  set(LIBGROONGA_METADATA_SOURCES
    "${CMAKE_CURRENT_BINARY_DIR}/metadata.rc")
else()
  set(LIBGROONGA_METADATA_SOURCES)
endif()

set_source_files_properties(
  ${LIBGROONGA_C_SOURCES}
  ${LIBGRNMRB_SOURCES}
  ${LIBGRNPROC_SOURCES}
  ${LIBGRNTS_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
set_source_files_properties(
  ${LIBGROONGA_C_SOURCES}
  ${LIBGROONGA_CPP_SOURCES}
  ${LIBGRNMRB_SOURCES}
  PROPERTIES
  COMPILE_DEFINITIONS "${MRUBY_DEFINITIONS}")
set_source_files_properties(
  ${LIBGROONGA_CPP_SOURCES}
  ${LIBGRNDAT_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_CXX_COMPILE_FLAGS}")

set(GRN_ALL_SOURCES
  ${LIBGROONGA_C_SOURCES}
  ${LIBGROONGA_CPP_SOURCES}
  ${LIBGRNDAT_SOURCES}
  ${LIBGRNMRB_SOURCES}
  ${LIBGRNPROC_SOURCES}
  ${LIBGRNTS_SOURCES}
  ${LIBGROONGA_METADATA_SOURCES})
if(GRN_EMBED)
  add_library(libgroonga STATIC ${GRN_ALL_SOURCES})
  set_target_properties(
    libgroonga
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(libgroonga SHARED ${GRN_ALL_SOURCES})
endif()
set_target_properties(libgroonga PROPERTIES OUTPUT_NAME "groonga")

set(GRN_ALL_LIBRARIES
    ${EXECINFO_LIBS}
    ${RT_LIBS}
    ${PTHREAD_LIBS}
    ${Z_LIBS}
    ${LIBLZ4_LIBS}
    ${LIBZSTD_LIBS}
    ${MESSAGE_PACK_LIBS}
    ${DL_LIBS}
    ${M_LIBS}
    ${WS2_32_LIBS}
    ${DBGHELP_LIBS}
    ${MRUBY_LIBS}
    ${ONIGMO_LIBS})
if(GRN_EMBED)
  set(GRN_EMBEDDED_PLUGIN_LIBRARIES "")
  if(GRN_WITH_MECAB)
    list(APPEND GRN_EMBEDDED_PLUGIN_LIBRARIES mecab_tokenizer)
  endif()
  target_link_libraries(libgroonga
    ${GRN_ALL_LIBRARIES}
    ${STDCPP_LIBS}
    ${GRN_EMBEDDED_PLUGIN_LIBRARIES})
else()
  target_link_libraries(libgroonga
    ${GRN_ALL_LIBRARIES})
  install(TARGETS libgroonga
    ARCHIVE DESTINATION "${LIB_DIR}"
    LIBRARY DESTINATION "${LIB_DIR}"
    RUNTIME DESTINATION "${BIN_DIR}")
  if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
    install(FILES $<TARGET_PDB_FILE:libgroonga>
      DESTINATION "${PDB_DIR}"
      OPTIONAL)
  endif()
endif()

if(GRN_WITH_MRUBY)
  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mrb/scripts/sources.am
    RUBY_SCRIPTS)
  string(REGEX REPLACE "([^;]+)" "mrb/scripts/\\1"
    RUBY_SCRIPTS "${RUBY_SCRIPTS}")
  install(
    FILES ${RUBY_SCRIPTS}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}")

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mrb/scripts/command_line/sources.am
    COMMANE_LINE_RUBY_SCRIPTS)
  string(REGEX REPLACE "([^;]+)" "mrb/scripts/command_line/\\1"
    COMMANE_LINE_RUBY_SCRIPTS "${COMMANE_LINE_RUBY_SCRIPTS}")
  install(
    FILES ${COMMANE_LINE_RUBY_SCRIPTS}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}/command_line")

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mrb/scripts/context/sources.am
    CONTEXT_RUBY_SCRIPTS)
  string(REGEX REPLACE "([^;]+)" "mrb/scripts/context/\\1"
    CONTEXT_RUBY_SCRIPTS "${CONTEXT_RUBY_SCRIPTS}")
  install(
    FILES ${CONTEXT_RUBY_SCRIPTS}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}/context")

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mrb/scripts/initialize/sources.am
    INITIALIZE_RUBY_SCRIPTS)
  string(REGEX REPLACE "([^;]+)" "mrb/scripts/initialize/\\1"
    INITIALIZE_RUBY_SCRIPTS "${INITIALIZE_RUBY_SCRIPTS}")
  install(
    FILES ${INITIALIZE_RUBY_SCRIPTS}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}/initialize")

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mrb/scripts/logger/sources.am
    LOGGER_RUBY_SCRIPTS)
  string(REGEX REPLACE "([^;]+)" "mrb/scripts/logger/\\1"
    LOGGER_RUBY_SCRIPTS "${LOGGER_RUBY_SCRIPTS}")
  install(
    FILES ${LOGGER_RUBY_SCRIPTS}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}/logger")

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mrb/scripts/query_logger/sources.am
    QUERY_LOGGER_RUBY_SCRIPTS)
  string(REGEX REPLACE "([^;]+)" "mrb/scripts/query_logger/\\1"
    QUERY_LOGGER_RUBY_SCRIPTS "${QUERY_LOGGER_RUBY_SCRIPTS}")
  install(
    FILES ${QUERY_LOGGER_RUBY_SCRIPTS}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}/query_logger")

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mrb/scripts/expression_tree/sources.am
    EXPRESSION_TREE_RUBY_SCRIPTS)
  string(REGEX REPLACE "([^;]+)" "mrb/scripts/expression_tree/\\1"
    EXPRESSION_TREE_RUBY_SCRIPTS "${EXPRESSION_TREE_RUBY_SCRIPTS}")
  install(
    FILES ${EXPRESSION_TREE_RUBY_SCRIPTS}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}/expression_tree")
endif()

=== src/CMakeLists.txt ===
# Copyright(C) 2012-2013 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include_directories(
  ${MRUBY_INCLUDE_DIRS}
  ${MESSAGE_PACK_INCLUDE_DIRS}
  )

add_subdirectory(suggest)

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/groonga_sources.am GROONGA_SOURCES)
add_executable(groonga ${GROONGA_SOURCES})
set_source_files_properties(${GROONGA_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
target_link_libraries(groonga libgroonga)
install(TARGETS groonga DESTINATION ${BIN_DIR})
if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
  install(FILES $<TARGET_PDB_FILE:groonga>
    DESTINATION "${PDB_DIR}"
    OPTIONAL)
endif()

if(GRN_WITH_MRUBY)
  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/grndb_sources.am GRNDB_SOURCES)
  add_executable(grndb ${GRNDB_SOURCES})
  set_source_files_properties(${GRNDB_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
  set_source_files_properties(${GRNDB_SOURCES}
    PROPERTIES
    COMPILE_DEFINITIONS "${MRUBY_DEFINITIONS}")
  target_link_libraries(grndb libgroonga)
  install(TARGETS grndb DESTINATION ${BIN_DIR})
  if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
    install(FILES $<TARGET_PDB_FILE:grndb>
      DESTINATION "${PDB_DIR}"
      OPTIONAL)
  endif()
endif()

if(NOT WIN32)
  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/grnslap_sources.am GRNSLAP_SOURCES)
  add_executable(grnslap ${GRNSLAP_SOURCES})
  set_source_files_properties(${GRNSLAP_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
  target_link_libraries(grnslap libgroonga)
  install(TARGETS grnslap DESTINATION ${BIN_DIR})
endif()

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/groonga_benchmark_sources.am
  GROONGA_BENCHMARK_SOURCES)
add_executable(groonga-benchmark ${GROONGA_BENCHMARK_SOURCES})
set_source_files_properties(${GROONGA_BENCHMARK_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
target_link_libraries(groonga-benchmark libgroonga)
install(TARGETS groonga-benchmark DESTINATION ${BIN_DIR})
if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
  install(FILES $<TARGET_PDB_FILE:groonga-benchmark>
    DESTINATION "${PDB_DIR}"
    OPTIONAL)
endif()

=== vendor/CMakeLists.txt ===
# Copyright(C) 2013-2016 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

add_subdirectory(lz4)
add_subdirectory(onigmo)
add_subdirectory(mruby)
add_subdirectory(mecab)
add_subdirectory(message_pack)

=== plugins/functions/CMakeLists.txt ===
# Copyright(C) 2015-2017 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../../lib
  )

set(GRN_FUNCTIONS_PLUGIN_DIR "${GRN_RELATIVE_PLUGINS_DIR}/functions")

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/vector_sources.am
  VECTOR_SOURCES)
set_source_files_properties(${VECTOR_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(vector_functions STATIC ${VECTOR_SOURCES})
  set_target_properties(
    vector_functions
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(vector_functions MODULE ${VECTOR_SOURCES})
  set_target_properties(vector_functions PROPERTIES
    PREFIX ""
    OUTPUT_NAME "vector")
  install(TARGETS vector_functions DESTINATION "${GRN_FUNCTIONS_PLUGIN_DIR}")
  if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
    install(FILES $<TARGET_PDB_FILE:vector_functions>
      DESTINATION "${PDB_DIR}"
      OPTIONAL)
  endif()
endif()
target_link_libraries(vector_functions libgroonga)

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/string_sources.am
  STRING_SOURCES)
set_source_files_properties(${STRING_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(string_functions STATIC ${STRING_SOURCES})
  set_target_properties(
    string_functions
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(string_functions MODULE ${STRING_SOURCES})
  set_target_properties(string_functions PROPERTIES
    PREFIX ""
    OUTPUT_NAME "string")
  install(TARGETS string_functions DESTINATION "${GRN_FUNCTIONS_PLUGIN_DIR}")
  if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
    install(FILES $<TARGET_PDB_FILE:string_functions>
      DESTINATION "${PDB_DIR}"
      OPTIONAL)
  endif()
endif()
target_link_libraries(string_functions libgroonga)

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/number_sources.am
  NUMBER_SOURCES)
set_source_files_properties(${NUMBER_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(number_functions STATIC ${NUMBER_SOURCES})
  set_target_properties(
    number_functions
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(number_functions MODULE ${NUMBER_SOURCES})
  set_target_properties(number_functions PROPERTIES
    PREFIX ""
    OUTPUT_NAME "number")
  install(TARGETS number_functions DESTINATION "${GRN_FUNCTIONS_PLUGIN_DIR}")
endif()
target_link_libraries(number_functions libgroonga "${M_LIBS}")

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/time_sources.am
  TIME_SOURCES)
set_source_files_properties(${TIME_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(time_functions STATIC ${TIME_SOURCES})
  set_target_properties(
    time_functions
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(time_functions MODULE ${TIME_SOURCES})
  set_target_properties(time_functions PROPERTIES
    PREFIX ""
    OUTPUT_NAME "time")
  install(TARGETS time_functions DESTINATION "${GRN_FUNCTIONS_PLUGIN_DIR}")
endif()
target_link_libraries(time_functions libgroonga)

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/index_column_sources.am
  INDEX_COLUMN_SOURCES)
set_source_files_properties(${INDEX_COLUMN_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(index_column_functions STATIC ${INDEX_COLUMN_SOURCES})
  set_target_properties(
    index_column_functions
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(index_column_functions MODULE ${INDEX_COLUMN_SOURCES})
  set_target_properties(index_column_functions PROPERTIES
    PREFIX ""
    OUTPUT_NAME "index_column")
  install(TARGETS index_column_functions
    DESTINATION "${GRN_FUNCTIONS_PLUGIN_DIR}")
endif()
target_link_libraries(index_column_functions libgroonga)

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/math_sources.am
  MATH_SOURCES)
set_source_files_properties(${MATH_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(math_functions STATIC ${MATH_SOURCES})
  set_target_properties(
    math_functions
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(math_functions MODULE ${MATH_SOURCES})
  set_target_properties(math_functions PROPERTIES
    PREFIX ""
    OUTPUT_NAME "math")
  install(TARGETS math_functions DESTINATION "${GRN_FUNCTIONS_PLUGIN_DIR}")
endif()
target_link_libraries(math_functions libgroonga)

=== plugins/query_expanders/CMakeLists.txt ===
# Copyright(C) 2012-2013 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../../lib
  )

set(QUERY_EXPANDERS_DIR "${GRN_RELATIVE_PLUGINS_DIR}/query_expanders")
read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/tsv_sources.am TSV_SOURCES)
set_source_files_properties(${TSV_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(tsv_query_expander STATIC ${TSV_SOURCES})
  set_target_properties(
    tsv_query_expander
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(tsv_query_expander MODULE ${TSV_SOURCES})
  set_target_properties(tsv_query_expander PROPERTIES
    PREFIX ""
    OUTPUT_NAME "tsv")
  install(TARGETS tsv_query_expander DESTINATION "${QUERY_EXPANDERS_DIR}")
  if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
    install(FILES $<TARGET_PDB_FILE:tsv_query_expander>
      DESTINATION "${PDB_DIR}"
      OPTIONAL)
  endif()
endif()
target_link_libraries(tsv_query_expander libgroonga)

=== plugins/suggest/CMakeLists.txt ===
# Copyright(C) 2012-2013 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../../lib
  ${MRUBY_INCLUDE_DIRS}
  ${MESSAGE_PACK_INCLUDE_DIRS})

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/sources.am SUGGEST_SOURCES)
set_source_files_properties(${SUGGEST_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(suggest STATIC ${SUGGEST_SOURCES})
  set_target_properties(
    suggest
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(suggest MODULE ${SUGGEST_SOURCES})
  set_target_properties(suggest PROPERTIES PREFIX "")
  install(TARGETS suggest DESTINATION "${GRN_RELATIVE_PLUGINS_DIR}/suggest")
  if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
    install(FILES $<TARGET_PDB_FILE:suggest>
      DESTINATION "${PDB_DIR}"
      OPTIONAL)
  endif()
endif()
target_link_libraries(suggest libgroonga)

=== plugins/token_filters/CMakeLists.txt ===
# Copyright(C) 2014 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../../lib
  )

set(TOKEN_FILTERS_DIR "${GRN_RELATIVE_PLUGINS_DIR}/token_filters")

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/stop_word_sources.am
  STOP_WORD_SOURCES)
set_source_files_properties(${STOP_WORD_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
if(GRN_EMBED)
  add_library(stop_word_token_filter STATIC ${STOP_WORD_SOURCES})
  set_target_properties(
    stop_word_token_filter
    PROPERTIES
    POSITION_INDEPENDENT_CODE ON)
else()
  add_library(stop_word_token_filter MODULE ${STOP_WORD_SOURCES})
  set_target_properties(stop_word_token_filter PROPERTIES
    PREFIX ""
    OUTPUT_NAME "stop_word")
  install(TARGETS stop_word_token_filter DESTINATION "${TOKEN_FILTERS_DIR}")
  if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
    install(FILES $<TARGET_PDB_FILE:stop_word_token_filter>
      DESTINATION "${PDB_DIR}"
      OPTIONAL)
  endif()
endif()
target_link_libraries(stop_word_token_filter libgroonga)

if(GRN_WITH_LIBSTEMMER)
  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/stem_sources.am STEM_SOURCES)
  include_directories(${LIBSTEMMER_INCLUDE_DIRS})
  link_directories(${LIBSTEMMER_LIBRARY_DIRS})
  set_source_files_properties(${STEM_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
  if(GRN_EMBED)
    add_library(stem_token_filter STATIC ${STEM_SOURCES})
    set_target_properties(
      stem_token_filter
      PROPERTIES
      POSITION_INDEPENDENT_CODE ON)
  else()
    add_library(stem_token_filter MODULE ${STEM_SOURCES})
    set_target_properties(stem_token_filter PROPERTIES
      PREFIX ""
      OUTPUT_NAME "stem")
    install(TARGETS stem_token_filter DESTINATION "${TOKEN_FILTERS_DIR}")
    if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
      install(FILES $<TARGET_PDB_FILE:stem_token_filter>
	DESTINATION "${PDB_DIR}"
	OPTIONAL)
    endif()
  endif()
  target_link_libraries(stem_token_filter libgroonga ${LIBSTEMMER_LIBRARIES})
endif()

=== plugins/tokenizers/CMakeLists.txt ===
# Copyright(C) 2012-2013 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../../lib
  )

set(TOKENIZERS_DIR "${GRN_RELATIVE_PLUGINS_DIR}/tokenizers")
if(GRN_WITH_MECAB)
  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/mecab_sources.am MECAB_SOURCES)
  include_directories(${MECAB_INCLUDE_DIRS})
  link_directories(${MECAB_LIBRARY_DIRS})
  if(GRN_WITH_BUNDLED_MECAB)
    set(GRN_BUNDLED_MECAB_RELATIVE_RC_PATH "${CONFIG_DIR}/mecabrc")
    set(MECAB_COMPILE_DEFINITIONS
      "GRN_WITH_BUNDLED_MECAB"
      "GRN_BUNDLED_MECAB_RELATIVE_RC_PATH=\"${GRN_BUNDLED_MECAB_RELATIVE_RC_PATH}\""
      "GRN_BUNDLED_MECAB_RC_PATH=\"${CMAKE_INSTALL_PREFIX}/${GRN_BUNDLED_MECAB_RELATIVE_RC_PATH}\"")
    set_source_files_properties(${MECAB_SOURCES}
      PROPERTIES
      COMPILE_DEFINITIONS
      "${MECAB_COMPILE_DEFINITIONS}")
  endif()
  set_source_files_properties(${MECAB_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
  if(GRN_EMBED)
    add_library(mecab_tokenizer STATIC ${MECAB_SOURCES})
    set_target_properties(
      mecab_tokenizer
      PROPERTIES
      POSITION_INDEPENDENT_CODE ON)
  else()
    add_library(mecab_tokenizer MODULE ${MECAB_SOURCES})
    set_target_properties(mecab_tokenizer PROPERTIES
      PREFIX ""
      OUTPUT_NAME "mecab")
    install(TARGETS mecab_tokenizer DESTINATION "${TOKENIZERS_DIR}")
    if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
      install(FILES $<TARGET_PDB_FILE:mecab_tokenizer>
	DESTINATION "${PDB_DIR}"
	OPTIONAL)
    endif()
  endif()
  target_link_libraries(mecab_tokenizer libgroonga ${MECAB_LIBRARIES})
endif()

if(GRN_WITH_KYTEA)
  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/kytea_sources.am KYTEA_SOURCES)
  include_directories(${KYTEA_INCLUDE_DIRS})
  link_directories(${KYTEA_LIBRARY_DIRS})
  set_source_files_properties(${KYTEA_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${GRN_CXX_COMPILE_FLAGS}")
  if(GRN_EMBED)
    add_library(kytea_tokenizer STATIC ${KYTEA_SOURCES})
    set_target_properties(
      kytea_tokenizer
      PROPERTIES
      POSITION_INDEPENDENT_CODE ON)
  else()
    add_library(kytea_tokenizer MODULE ${KYTEA_SOURCES})
    set_target_properties(kytea_tokenizer PROPERTIES
      PREFIX ""
      OUTPUT_NAME "kytea")
    install(TARGETS kytea_tokenizer DESTINATION "${TOKENIZERS_DIR}")
    if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
      install(FILES $<TARGET_PDB_FILE:kytea_tokenizer>
	DESTINATION "${PDB_DIR}"
	OPTIONAL)
    endif()
  endif()
  target_link_libraries(kytea_tokenizer libgroonga ${KYTEA_LIBRARIES})
endif()

=== src/suggest/CMakeLists.txt ===
# Copyright(C) 2012-2013 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../../lib
  ${MRUBY_INCLUDE_DIRS}
  ${MESSAGE_PACK_INCLUDE_DIRS})

read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/create_dataset_sources.am
  GROONGA_SUGGEST_CREATE_DATASET_SOURCES)
add_executable(groonga-suggest-create-dataset
  ${GROONGA_SUGGEST_CREATE_DATASET_SOURCES})
set_source_files_properties(${GROONGA_SUGGEST_CREATE_DATASET_SOURCES}
  PROPERTIES
  COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
target_link_libraries(groonga-suggest-create-dataset libgroonga)
install(
  TARGETS groonga-suggest-create-dataset
  DESTINATION ${BIN_DIR})
if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
  install(FILES $<TARGET_PDB_FILE:groonga-suggest-create-dataset>
    DESTINATION "${PDB_DIR}"
    OPTIONAL)
endif()

if(GRN_WITH_LIBEVENT AND GRN_WITH_ZEROMQ AND GRN_WITH_MESSAGE_PACK)
  set(GRN_WITH_SUGGEST_LEARNER TRUE)
else()
  set(GRN_WITH_SUGGEST_LEARNER FALSE)
endif()

if(GRN_WITH_SUGGEST_LEARNER)
  include_directories(
    ${LIBEVENT_INCLUDE_DIRS}
    ${ZEROMQ_INCLUDE_DIRS}
    ${MESSAGE_PACK_INCLUDE_DIRS}
    )
  link_directories(
    ${LIBEVENT_LIBRARY_DIRS}
    ${ZEROMQ_LIBRARY_DIRS}
    ${MESSAGE_PACK_LIBRARY_DIRS}
    )

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/util_sources.am
    GROONGA_SUGGEST_UTIL_SOURCES)
  add_library(groonga-suggest-util STATIC ${GROONGA_SUGGEST_UTIL_SOURCES})
  set_source_files_properties(${GROONGA_SUGGEST_UTIL_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/learner_sources.am
    GROONGA_SUGGEST_LEARNER_SOURCES)
  add_executable(groonga-suggest-learner ${GROONGA_SUGGEST_LEARNER_SOURCES})
  set_source_files_properties(${GROONGA_SUGGEST_LEARNER_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
  target_link_libraries(groonga-suggest-learner
    groonga-suggest-util
    libgroonga
    ${LIBEVENT_LIBRARIES}
    ${ZEROMQ_LIBRARIES}
    ${MESSAGE_PACK_LIBRARIES})

  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/httpd_sources.am
    GROONGA_SUGGEST_HTTPD_SOURCES)
  add_executable(groonga-suggest-httpd ${GROONGA_SUGGEST_HTTPD_SOURCES})
  set_source_files_properties(${GROONGA_SUGGEST_HTTPD_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")
  target_link_libraries(groonga-suggest-httpd
    groonga-suggest-util
    libgroonga
    ${LIBEVENT_LIBRARIES}
    ${ZEROMQ_LIBRARIES}
    ${MESSAGE_PACK_LIBRARIES})

  install(
    TARGETS groonga-suggest-learner groonga-suggest-httpd
    DESTINATION ${BIN_DIR})
  if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
    install(
      FILES
      $<TARGET_PDB_FILE:groonga-suggest-learner>
      $<TARGET_PDB_FILE:groonga-suggest-httpd>
      DESTINATION "${PDB_DIR}"
      OPTIONAL)
  endif()
endif()

=== vendor/groonga-log/CMakeLists.txt ===
# Copyright(C) 2017 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(GROONGA_LOG_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../groonga-log-source")

if(GRN_WITH_MRUBY)
  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/ruby_scripts_sources.am
    RUBY_SCRIPTS_SOURCES)
  read_file_list(${CMAKE_CURRENT_SOURCE_DIR}/ruby_scripts_groonga_log_sources.am
    RUBY_SCRIPTS_GROONGA_LOG_SOURCES)
  install(
    FILES ${RUBY_SCRIPTS}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}")
  install(
    FILES ${RUBY_SCRIPTS_GROONGA_LOG_SOURCES}
    DESTINATION "${GRN_RELATIVE_RUBY_SCRIPTS_DIR}/groonga-log")
  install(
    FILES
    "${GROONGA_LOG_SOURCE_DIR}/README.md"
    "${GROONGA_LOG_SOURCE_DIR}/doc/text/lgpl-2.1.txt"
    DESTINATION "${GRN_DATA_DIR}/groonga-log"
endif()

=== vendor/lz4/CMakeLists.txt ===
# Copyright(C) 2016 Brazil
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License version 2.1 as published by the Free Software Foundation.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

set(LZ4_VERSION ${GRN_BUNDLED_LZ4_VERSION})

set(LZ4_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../lz4-${LZ4_VERSION}")
set(LZ4_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/../lz4-${LZ4_VERSION}")

if(GRN_WITH_BUNDLED_LZ4)
  include_directories(
    BEFORE
    ${LZ4_BINARY_DIR}
    "${LZ4_SOURCE_DIR}/lib"
    )

  set(LIBLZ4_SOURCES
    "${LZ4_SOURCE_DIR}/lib/lz4.c"
    "${LZ4_SOURCE_DIR}/lib/lz4.h"
    "${LZ4_SOURCE_DIR}/lib/lz4frame.c"
    "${LZ4_SOURCE_DIR}/lib/lz4frame.h"
    "${LZ4_SOURCE_DIR}/lib/lz4frame_static.h"
    "${LZ4_SOURCE_DIR}/lib/lz4hc.c"
    "${LZ4_SOURCE_DIR}/lib/lz4hc.h"
    "${LZ4_SOURCE_DIR}/lib/xxhash.c"
    "${LZ4_SOURCE_DIR}/lib/xxhash.h"
    )
  set(LZ4_SOURCES
    "${LZ4_SOURCE_DIR}/programs/lz4cli.c"
    "${LZ4_SOURCE_DIR}/programs/lz4io.c"
    "${LZ4_SOURCE_DIR}/programs/lz4io.h"
    "${LZ4_SOURCE_DIR}/programs/bench.c"
    "${LZ4_SOURCE_DIR}/programs/bench.h"
    "${LZ4_SOURCE_DIR}/programs/datagen.c"
    "${LZ4_SOURCE_DIR}/programs/datagen.h"
    "${LZ4_SOURCE_DIR}/programs/platform.h"
    "${LZ4_SOURCE_DIR}/programs/util.h"
    ${LIBLZ4_SOURCES})

  set(LZ4_C_COMPILE_FLAGS "${GRN_C_COMPILE_FLAGS}")

  add_definitions("-DXXH_NAMESPACE=LZ4_")
  if(MSVC)
    add_definitions("-DLZ4_DLL_EXPORT=1")
  endif()
  set_source_files_properties(${LIBLZ4_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${LZ4_C_COMPILE_FLAGS}")
  set_source_files_properties(${LZ4_SOURCES}
    PROPERTIES
    COMPILE_FLAGS "${LZ4_C_COMPILE_FLAGS}")

  if(GRN_BUNDLED)
    add_library(liblz4 STATIC ${LIBLZ4_SOURCES})
    set_target_properties(
      liblz4
      PROPERTIES
      POSITION_INDEPENDENT_CODE ON)
  else()
    add_library(liblz4 SHARED ${LIBLZ4_SOURCES})
  endif()
  if(NOT MSVC)
    set_target_properties(liblz4 PROPERTIES OUTPUT_NAME "lz4")
  endif()

  if(NOT GRN_BUNDLED)
    add_executable(lz4 ${LZ4_SOURCES})

    install(TARGETS liblz4
      ARCHIVE DESTINATION "${LIB_DIR}"
      LIBRARY DESTINATION "${LIB_DIR}"
      RUNTIME DESTINATION "${BIN_DIR}")
    install(TARGETS lz4
      DESTINATION "${BIN_DIR}")
    if(MSVC AND CMAKE_VERSION VERSION_GREATER "3.1")
      install(FILES $<TARGET_PDB_FILE:lz4>
	DESTINATION "${PDB_DIR}"
	OPTIONAL)
    endif()
    install(FILES
      "${LZ4_SOURCE_DIR}/lib/lz4.h"
      "${LZ4_SOURCE_DIR}/lib/lz4frame.h"
      "${LZ4_SOURCE_DIR}/lib/lz4hc.h"
      DESTINATION "${INCLUDE_DIR}")
  endif()

  install(FILES
    "${LZ4_SOURCE_DIR}/lib/LICENSE"
    "${LZ4_SOURCE_DIR}/programs/COPYING"
    "${LZ4_SOURCE_DIR}/README.md"
    DESTINATION "${GRN_DATA_DIR}/lz4")
endif()

=== debian/changelog ===
groonga (8.0.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Bump Standards-Version, no other changes are required.

 -- Kentaro Hayashi <hayashi@clear-code.com>  Wed, 14 Feb 2018 23:35:34 +0900

groonga (7.1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Bump Standards-Version, no other changes are required.

 -- Kentaro Hayashi <hayashi@clear-code.com>  Tue, 30 Jan 2018 17:59:15 +0900

groonga (7.1.0-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/fix-nginx-FTBFS-on-kfreebsd.patch
    - Refresh patch to fix FTBFS on kFreeBSD.
  * debian/control
    - Bump Standards-Version, no other changes are required.

 -- Kentaro Hayashi <hayashi@clear-code.com>  Fri, 29 Dec 2017 13:17:40 +0900

groonga (7.0.9-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/fix-nginx-FTBFS-on-kfreebsd.patch
    - Refresh patch to fix FTBFS on kFreeBSD.

 -- Kentaro Hayashi <hayashi@clear-code.com>  Sun, 03 Dec 2017 13:18:43 +0900

groonga (7.0.8-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/fix-nginx-FTBFS-on-kfreebsd.patch
    - Refresh patch to fix FTBFS on kFreeBSD.

 -- Kentaro Hayashi <hayashi@clear-code.com>  Wed, 01 Nov 2017 10:01:58 +0900

groonga (7.0.7-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Bump version to 4.1.1 (no other changes are required)
  * debian/patches/fix-nginx-FTBFS-on-kfreebsd.patch
    - Refresh patch to fix FTBFS on kFreeBSD.

 -- Kentaro Hayashi <hayashi@clear-code.com>  Sun, 08 Oct 2017 09:28:30 +0900

=== debian/control ===
Source: groonga
Section: database
Priority: optional
Maintainer: Groonga Project <packages@groonga.org>
Uploaders: Kentaro Hayashi <hayashi@clear-code.com>
Build-Depends:
  debhelper (>= 10),
  pkg-config,
  liblz4-dev,
  zlib1g-dev,
  libmsgpack-dev,
  libzmq3-dev | libzmq-dev,
  libevent-dev,
  libmecab-dev,
  libpcre3-dev,
  libstemmer-dev,
  libjemalloc-dev,
  libssl-dev,
  libzstd-dev
Standards-Version: 4.1.3
Homepage: http://groonga.org/

Package: groonga
Architecture: any
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  groonga-bin (= ${binary:Version}),
  groonga-plugin-suggest (= ${binary:Version}),
  groonga-doc (= ${source:Version})
Description: Fulltext search engine (metapackage for library use)
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package depends all Groonga related package for library use.

Package: groonga-server-common
Architecture: all
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  adduser,
  groonga (>= ${source:Version})
Description: Fulltext search engine (metapackage for server use)
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides common settings for server use.

Package: groonga-server-gqtp
Architecture: all
Replaces: groonga-server (<< 2.0.7-1)
Breaks: groonga-server (<< 2.0.7-1)
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  adduser,
  groonga-server-common (= ${binary:Version}),
  lsb-base
Description: Fulltext search engine (metapackage for GQTP server use)
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package depends all Groonga related package for GQTP server use.

Package: libgroonga-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Replaces: libgroonga (<< 1.2.0-1)
Breaks: libgroonga (<< 1.2.0-1)
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  pkg-config,
  libgroonga0 (= ${binary:Version})
Description: Development files to use Groonga as a library
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides header files to use Groonga as a library.

Package: libgroonga0
Section: libs
Architecture: any
Multi-Arch: same
Replaces: libgroonga (<< 1.2.0-1)
Breaks: libgroonga (<< 1.2.0-1)
Pre-Depends: ${misc:Pre-Depends}
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  liblz4-1,
  zlib1g,
  libjemalloc1
Description: Library files for Groonga
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides library files.

Package: groonga-tokenizer-mecab
Section: libs
Architecture: any
Replaces: libgroonga-tokenizer-mecab (<< 1.2.0-1)
Breaks: libgroonga-tokenizer-mecab (<< 1.2.0-1)
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libgroonga0 (= ${binary:Version}),
  mecab-naist-jdic | mecab-jumandic-utf8
Description: MeCab tokenizer for Groonga
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides MeCab tokenizer.

Package: groonga-token-filter-stem
Section: libs
Architecture: any
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libgroonga0 (= ${binary:Version}),
  libstemmer0d
Description: Stemming token filter for Groonga
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides TokenFilterStem token filter that stem each token.
 The token filter uses libstemmer that uses stemming algorithm written
 by Snowball.

Package: groonga-plugin-suggest
Section: libs
Architecture: any
Replaces: libgroonga-plugin-suggest (<< 1.2.0-1)
Breaks: libgroonga-plugin-suggest (<< 1.2.0-1)
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libgroonga0 (= ${binary:Version})
Description: Suggest plugin for Groonga
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides suggest plugin.

Package: groonga-bin
Architecture: any
Replaces: groonga (<< 1.2.0-1)
Breaks: groonga (<< 1.2.0-1)
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  libgroonga0 (= ${binary:Version})
Description: Commands for Groonga
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides 'groonga' command.

Package: groonga-httpd
Architecture: any
Replaces: groonga (<< 1.2.0-1), groonga-server-http (<< 4.0.8-1)
Breaks: groonga (<< 1.2.0-1), groonga-server-http (<< 4.0.8-1)
Provides: groonga-server-http
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  curl,
  groonga-server-common (= ${source:Version}),
  lsb-base
Description: Groonga HTTP server
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides 'groonga-httpd' command.

Package: groonga-doc
Section: doc
Architecture: all
Depends:
  ${misc:Depends},
  libjs-underscore,
  libjs-jquery
Description: Documentation of Groonga
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides documentation of Groonga.

Package: groonga-examples
Architecture: all
Depends:
  ${misc:Depends},
  ${shlibs:Depends},
  groonga-bin (>= ${source:Version}),
  ruby
Description: Examples of Groonga
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides examples of Groonga.

Package: groonga-munin-plugins
Section: net
Architecture: all
Depends:
  ${misc:Depends},
  groonga-bin (>= ${source:Version}),
  munin-node,
  ruby
Description: munin-node plugins for Groonga
 Groonga is an open-source fulltext search engine and column store.
 It lets you write high-performance applications that requires fulltext search.
 .
 This package provides munin-node plugins to monitor Groonga.

=== debian/tests/control ===
Tests: build, status
Depends: libgroonga-dev, build-essential, pkg-config, groonga-httpd, curl, jq

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://packages.groonga.org/source/groonga groonga-(.*)\.tar\.gz debian uupdate
